<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24" style="margin-top: 10px">
            <Form id="formId" v-show="searchOpen" :label-width="90" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="委托单位:">
                <Input v-model="formObj.client" @on-enter="_formSearch" name="client" placeholder="请输入委托单位" clearable/>
              </Form-item>
              <Form-item class="search-item" label="合同编号:">
                <Input v-model="formObj.salesCode" @on-enter="_formSearch" name="salesCode" placeholder="请输入合同编号" clearable/>
              </Form-item>
              <Form-item class="search-btn">
                <Button @click="_formSearch" type="primary">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <!--操作-->
          <Col span="24">

            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" @on-result-change="_btnClick"
                     class="contHide"></btn-list>
          </Col>
          <!--表格-->
          <Col span="24">
            <PTVXETable ref="pageTable" :table-height="tableHeight" :form-id="formId" :loading="true"
                        :get-page="getPage" :icon-msg="iconMsg" @on-result-change="_tableResultChange">
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                  <span v-if="item.date">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}</span>
                  <span v-else>{{scope.row[item.key]}}</span>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </div>
    <FileManage ref="FileManage"></FileManage>
    <Reason ref="reasonModal" @on-result-change="_reasonResult"></Reason>
    <MeterSendOperation ref="operationModal"></MeterSendOperation>
    <MeterSubcontractorEdit ref="editSubcontractorModal" @on-result-change="_formSearch"></MeterSubcontractorEdit>
    <MeterSubcontractorAddEdit ref="addEditModal" @on-result-change="_page"></MeterSubcontractorAddEdit>
    <MeterSampleManage ref="meterSampleManageModal"  @on-result-change="_page"></MeterSampleManage>
  </div>
</template>
<script>
import { meterContract, meterSubcontractor } from '../../../api'
import Reason from '../../../components/base/Reason'
import MeterSendOperation from '../MeterContractReviewOperation'
import MeterSampleManage from '../MeterSampleQuoteManage'
import MeterSubcontractorEdit from './MeterContractFileEdit'
import MeterSubcontractorAddEdit from './MeterContractReviewAddEdit'
export default {
  components: {
    MeterSubcontractorEdit,
    MeterSendOperation,
    MeterSubcontractorAddEdit,
    MeterSampleManage,
    Reason
  },
  data() {
    return {
      currentComponent: '',
      formId: 'meterContractReviewFormId',
      searchOpen: false,
      btn: [
        // {
        //   type: 'success',
        //   id: '',
        //   name: '评审'
        // },
        // {
        //   type: 'success',
        //   id: '',
        //   name: '驳回'
        // }
      ],
      iconMsg: [
        {
          type: 'md-create',
          id: 'meter-contract-file-review-record-operation',
          name: '评审记录'
        },
        {
          type: 'ios-beaker',
          id: 'meter-contract-file-sample-manage-operation',
          name: '样品管理'
        },
        {
          type: 'md-cloud',
          id: 'meter-contract-file-accessory-operation',
          name: '附件'
        },
        {
          type: 'ios-clock',
          id: 'meter-contract-file-record-operation',
          name: '操作日志'
        }
      ],
      formObj: {
        client: undefined,
        entrustCode: undefined,
        salesCode: undefined
      },
      selectIds: [],
      getPage: {},
      pageColumns: [
        { title: '委托单位', key: 'client', width: 200 },
        { title: '联系人', key: 'person', width: 120 },
        { title: '联系电话', key: 'tel', width: 120 },
        { title: '合同编号', key: 'salesCode', width: 100 },
        { title: '传真', key: 'fax', width: 120 },
        { title: '详细地址', key: 'address', width: 250 },
        { title: '要求完成时间', key: 'odate', width: 120, date: true },
        { title: '折扣', key: 'discount', width: 120 },
        { title: '总价', key: 'totalPrice', width: 120 },
        { title: '折扣价', key: 'discountPrice', width: 120 },
        { title: '备注', key: 'remark' }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (msg) {
          case '评审记录':
            this._reviewContract(false)
            break
          case '驳回':
            this._goBack()
            break
          case '提交':
            this._submitToReview()
            break
          case 'search':
            this.searchOpen = !this.searchOpen
            break
        }
      })
    },
    _goBack() {
      // 退回
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选择一条委托！')
      } else {
        this.$refs.reasonModal._open('退回原因')
      }
    },
    _reasonResult(data) {
      if (undefined !== data && data !== '') {
        console.log('退回')
      }
      console.log(data)
    },
    _manageSample(data) {
      // 管理样品
      this.$refs.meterSampleManageModal._open(data)
    },
    _iconClick(res, data, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (res) {
          case '评审记录':
            this._reviewContract(data.id)
            break
          case '样品管理':
            this._manageSample(data.id)
            break
          case '附件':
            this._upload(data.id)
            break
          case '删除':
            this._deleteByIds([data.id])
            break
          case '操作日志':
            this._record(data.id)
            break
        }
      })
    },
    _submitToReview() {
      this._submitByContractIds('合同评审')
    },
    _submitByContractIds(cont) {
      const ids = this.selectIds
      if (ids.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$Modal.confirm({
          title: '提示',
          content: '确定要把这 ' + ids.length + ' 条记录提交到' + cont + '？',
          onOk: () => {
            const result = meterContract.submitToContractReview(ids)
            if (result) {
              this._resultChange('提交成功')
              console.log(result)
            }
            // })
          }
        })
      }
    },
    _resultChange(msg) {
      this.$Message.success(msg)
      this._page()
    },
    _record(id) {
      this.$refs.operationModal._open(id)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'selectIds':
          this.selectIds = data
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.componentName)
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await meterContract.pageContractFile(this.formObj)
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    // 删除
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this._delete(ids)
        }
      })
    },
    // 编辑&添加
    _reviewContract(id) {
      this._getContractReview(id)
    },

    _getContractReview: async function(id) {
      const result = await meterContract.getReviewRecordById(id)
      if (result) {
        this.$refs.addEditModal._openEdit(result)
      }
    },

    // 追加项目
    _itemModal(data) {
      this.$refs.refModal._open(data)
    },

    _upload(id) {
      // 上传文件
      this.$refs.FileManage._open(id, 'subcontractorId')
    },
    _getById: async function(id) {
      const result = await meterContract.getVOById(id)
      if (result) {
        this.$refs.editSubcontractorModal._openEdit(result)
      }
    },
    _delete: async function(ids) {
      const result = await meterSubcontractor.deleteById(ids)
      if (result) {
        this._formSearch()
        this.$Message.success('删除成功！')
      }
    }
  }
}
</script>
